Type PlayerUDT
    Dim as Integer X
    Dim as Integer Y
    Dim as Integer LastX
    Dim as Integer LastY
    Dim as Byte Rot
    Dim as Byte Anim
    
    Dim as Byte Active
    Dim as UInteger ConID
    
    Dim as Any PTR PlayerImg(1 to 8)
    
    Dim as Sub(XPos as Integer, YPos as Integer, ID as UInteger) NewPosEvent
    
    Declare Constructor(XPos as Integer, YPos as Integer, NewPos as Sub(XPos as Integer, YPos as Integer, ID as UInteger))
    Declare Constructor()
    Declare Sub LoadFiles()
    Declare Sub Control()
    Declare Sub G()
    Declare Sub GClear()
End Type

'###############################################################################
Constructor PlayerUDT(XPos as Integer, YPos as Integer, NewPos as Sub(XPos as Integer, YPos as Integer, ID as UInteger))
    NewPosEvent = NewPos

    X = XPos
    Y = YPos
    Active = 1
    
    LoadFiles()
End Constructor

'###############################################################################
Constructor PlayerUDT()
    LoadFiles()
End Constructor

'###############################################################################
Sub PlayerUDT.LoadFiles()
    Dim a as Integer
    
    PlayerImg(1) = LoadImgFile("imgs\player\PlayerUp1.bmp")
    PlayerImg(2) = LoadImgFile("imgs\player\PlayerDown1.bmp")
    PlayerImg(3) = LoadImgFile("imgs\player\PlayerLeft1.bmp")
    PlayerImg(4) = LoadImgFile("imgs\player\PlayerRight1.bmp")
    PlayerImg(5) = LoadImgFile("imgs\player\PlayerUp2.bmp")
    PlayerImg(6) = LoadImgFile("imgs\player\PlayerDown2.bmp")
    PlayerImg(7) = LoadImgFile("imgs\player\PlayerLeft2.bmp")
    PlayerImg(8) = LoadImgFile("imgs\player\PlayerRight2.bmp")
    
    For a = 1 to 8
        If PlayerImg(a) = 0 then
            ?"[Error]Something went wrong while loading .bmp files."
            Sleep
            End -1
        Endif
    Next a
End Sub

'###############################################################################
Sub PlayerUDT.Control()
    If Active = 1 then
        LastX = X
        LastY = Y
        
        If Multikey(&h11) then 
            Y -= PlayerSpeed
            Rot = 0 
            Anim += 1
            NewPosEvent(X, Y, ConID)
        ElseIf Multikey(&h1F) then 
            Y += PlayerSpeed
            Rot = 1
            Anim += 1
            NewPosEvent(X, Y, ConID)
        ElseIf Multikey(&h1E) then 
            X -= PlayerSpeed
            Rot = 2
            Anim += 1
            NewPosEvent(X, Y, ConID)
        ElseIf Multikey(&h20) then 
            X += PlayerSpeed
            Rot = 3
            Anim += 1
            NewPosEvent(X, Y, ConID)
        Endif
        
        If Anim > AnimMax then Anim = 0
        If Y < 0 then Y = 0
        If X < 0 then X = 0
        If Y > ScreenMaxY - PHeight then Y = ScreenMaxY - PHeight
        If X > ScreenMaxX - PWidth then X = ScreenMaxX - PWidth
    Endif
End Sub

'###############################################################################
Sub PlayerUDT.G()
    If Active = 1 then
        Select Case Rot
        Case 0
            If Anim < AnimMax / 2 then 
                Put (X, Y), PlayerImg(1), ALPHA, 255
            Else 
                Put (X, Y), PlayerImg(5), ALPHA, 255
            Endif
        Case 1
            If Anim < AnimMax / 2 then 
                Put (X, Y), PlayerImg(2), ALPHA, 255
            Else 
                Put (X, Y), PlayerImg(6), ALPHA, 255
            Endif
        Case 2
            If Anim < AnimMax / 2 then 
                Put (X, Y), PlayerImg(3), ALPHA, 255
            Else 
                Put (X, Y), PlayerImg(7), ALPHA, 255
            Endif
        Case 3
            If Anim < AnimMax / 2 then 
                Put (X, Y), PlayerImg(4), ALPHA, 255
            Else 
                Put (X, Y), PlayerImg(8), ALPHA, 255
            Endif
        End Select
    Endif
End Sub

'###############################################################################
Sub PlayerUDT.GClear()
    Line (LastX, LastY) - (LastX + PWidth, LastY + PHeight), &h000000, BF
End Sub



