#Include "Defines.bi"
#Include "TSNE_V3.bi"
#Include "ServPlayerUDT.bi"


Declare Sub	Disconnected(V_TSNEID as UInteger)
Declare Sub	Connected(V_TSNEID as UInteger)
Declare Sub	NewData(V_TSNEID as UInteger, ByRef V_Data as String)
Declare Sub NewConnection(V_TSNEID as UInteger, ByVal V_RequestID as Socket, ByVal V_IPA as String)
Declare Sub NewConnectionCanceled(V_TSNEID as UInteger, ByVal V_IPA as String)
Declare Sub LoadMap()
Declare Sub GetNewPos(D as String, ID as UInteger)
Declare Sub SendNewPos(X as Integer, Y as Integer, Player as Byte)


Dim Shared as Byte ServPlayerCounter = 1
Dim Shared as Long RV
Dim Shared as UInteger Server
Dim Shared as Byte Area(1 to 18, 1 to 15)
Dim as UShort Port = 33222

Dim Shared as ServPlayerUDT ServPlayer(1 to 4)

RV = TSNE_Create_Server(Server, Port, 4, @NewConnection, @NewConnectionCanceled)
If RV <> TSNE_Const_NoError Then
    Print "[FEHLER] " & TSNE_GetGURUCode(RV)
    Sleep
    End -1
End If

LoadMap()



While(NOT Multikey(&h01))
    Sleep 10
Wend

End 0


'###############################################################################
Sub Disconnected(V_TSNEID as UInteger)
    ?"[Player disconnected]"
End Sub

'###############################################################################
Sub	Connected(V_TSNEID as UInteger)
    ?"[Player accepted]"
End Sub

'###############################################################################
Sub	NewData(V_TSNEID as UInteger, ByRef V_Data as String)
    Select Case V_Data[0]
    Case 1
        GetNewPos(V_Data, V_TSNEID)
    End Select
End Sub

'###############################################################################
Sub NewConnection(V_TSNEID as UInteger, ByVal V_RequestID as Socket, ByVal V_IPA as String)
    ?"[New connection]"
    Dim as String IP
    Dim as UInteger NewID
    If ServPlayerCounter < 5 then
        TSNE_Create_Accept(V_RequestID, NewID, IP, @Disconnected, @Connected, @NewData)
        ServPlayer(ServPlayerCounter).ID = NewID
        ServPlayerCounter += 1
    Endif
End Sub

'###############################################################################
Sub NewConnectionCanceled(V_TSNEID as UInteger, ByVal V_IPA as String)
    ?"[Connection not accepted]"
End Sub

'###############################################################################
Sub LoadMap()
    Dim as Integer File = Freefile
    Dim as Integer a, b
    
    If Open("map\Map" for Random Access Read as #File) <> 0 then
        ?"[Error]Something went wrong while loading map file."
        Sleep
        End -1
    Endif
        
    For a = 1 to 18
        For b = 1 to 15
            Get #File,, Area(a, b)
        Next b
    Next a
    Close #File
End Sub

'###############################################################################
Sub GetNewPos(D as String, ID as UInteger)
    Dim as Integer a, b
    
    For a = 1 to 4
        If ServPlayer(a).ID = ID then
            ServPlayer(a).X = CVI(MID(D, 2, 5))
            ServPlayer(a).Y = CVI(MID(D, 6, 9))
            For b = 1 to 4
                If b <> a and ServPlayer(b).ID <> 0 then SendNewPos(ServPlayer(a).X, ServPlayer(a).Y, b) : ?"Send"
            Next b
        Endif
    Next a
End Sub

'###############################################################################
Sub SendNewPos(X as Integer, Y as Integer, Player as Byte)
    Dim as Integer BV
    Dim as String D = String(10, CHR(0))
    D[0] = 1
    D[1] = MKI(X)
    D[5] = MKI(Y)
    D[9] = Player
    
    
    BV = TSNE_Data_Send(ServPlayer(Player).ID, D)
    If BV <> TSNE_Const_NoError Then ?"[FEHLER] " & TSNE_GetGURUCode(BV)
End Sub

